package com.jdauny.client;
import javax.swing.*;
import java.awt.event.*;
import java.awt.*;

public class Dialog_IDImport extends JDialog implements ActionListener
{
        boolean result;
        public String m_sName;
        public int m_iID;

        JButton ok;
        JButton cancel;
        JLabel m_lID;
        JLabel m_lName;
        JTextField m_tID;
        JTextField m_tName;
        JPanel panelButton;
        JPanel panel0;
        JPanel panel1;
        JPanel panel3;
        JFrame m_fOwner;
        Checkbox m_cbProxy;

        public Dialog_IDImport(JFrame owner)
        {
                super(owner,"ID Import",true);
                m_fOwner = owner;
                buildGUI();
                setupActionListener();
                setResizable(false);
        }

        void buildGUI()
        {
                ok = new JButton("Ok");
                cancel = new JButton("Cancel");
                panelButton = new JPanel();
                panel0 = new JPanel();
                panel1 = new JPanel();
//		panel1 = new JPanel();
//		panel3 = new JPanel();

                m_lName =new JLabel("Name:");
                m_lID = new JLabel("ID:");


                panel0.setLayout(new GridLayout(4,1));
                panel1.setLayout(new GridLayout(4,1));
                m_tID = new JTextField(10);
                m_tName = new JTextField(10);

                panel0.add(m_lID);
                panel0.add(m_tID);
                panel1.add(m_lName);
                panel1.add(m_tName);

                panelButton.add(ok);
                panelButton.add(cancel);
 //		getContentPane().add("Center",panel3);
                  getContentPane().add("South",panelButton);
                 getContentPane().add("West",panel0);
                getContentPane().add("East",panel1);
                pack();
        }

        public void changeLook_Feel(String which)
        {
                try
                {
                        UIManager.setLookAndFeel(which);
                         SwingUtilities.updateComponentTreeUI(this);

                }
                catch(Exception E)
                {
                        // Fehler beim Wechseln
                }
        }

        void setupActionListener()
        {
                ok.addActionListener(this);
                cancel.addActionListener(this);
        }

        public boolean isOk()
        {
                return result;
        }

        public void doModal()
        {
                result =false;
                Point parloc = m_fOwner.getLocation();
                int x = m_fOwner.getWidth() - getWidth();
                int y = m_fOwner.getHeight() - getHeight();
                setLocation(parloc.x + x/2, parloc.y + y/2);
                setVisible(true);
        }

        public void actionPerformed(ActionEvent event)
        {
                result = event.getActionCommand().equals("Ok");
                if (result)
                {
                        m_sName = m_tName.getText();
                        m_iID = Integer.parseInt(m_tID.getText());
                }
                setVisible(false);
                dispose();
        }

}
