package com.jdauny.client;
import javax.swing.*;
import java.awt.event.*;
import java.awt.*;

public class Dialog_Server extends JDialog implements ActionListener
{
	boolean result,m_bProxy;
	public String m_sServer,m_sUser,m_sPwd,m_sProxyServer;
	public int m_iPort,m_iProxyPort;
	
	JButton ok;
	JButton cancel;
	JLabel lServer;
	JLabel lUser;
	JLabel lPort;
	JLabel lPwd;
	JLabel lProxyServer;
	JLabel lProxyPort;
	JTextField m_tServer;
	JTextField m_tPort;
	JTextField m_tUser;
	JPasswordField m_tPwd;
	JTextField m_tProxyServer;
	JTextField m_tProxyPort;
	JPanel panelButton;
	JPanel panel0;
	JPanel panel1;
	JPanel panel3;
	JFrame m_fOwner;
	Checkbox m_cbProxy;
	
	public Dialog_Server(JFrame owner)
	{
		super(owner,"Server Options",true);
		m_fOwner = owner;
		buildGUI();
		setupActionListener();
		setResizable(false);
	}
	
	void buildGUI()
	{
		ok = new JButton("Ok");
		cancel = new JButton("Cancel");
		panelButton = new JPanel();
 		panel0 = new JPanel();
		panel1 = new JPanel();
//		panel1 = new JPanel();	
//		panel3 = new JPanel();
		
		panel0.setLayout(new GridLayout(4,1)); 
		panel1.setLayout(new GridLayout(4,1));		
		m_tServer = new JTextField(10);
		m_tPort = new JTextField(6);
		m_tUser = new JTextField(8);
		m_tPwd = new JPasswordField(8);
		m_tProxyServer = new JTextField(10);
		m_tProxyPort = new JTextField(6);
		m_cbProxy = new Checkbox(" use Proxy",false);
		lServer = new JLabel("Server:");
		lPort = new JLabel("Port:");
		lUser = new JLabel("User:");
		lPwd = new JLabel("Pwd:");
		lProxyServer = new JLabel("Proxyserver:");
		lProxyPort = new JLabel("Proxyport:"); 
/*		
		panel1.setLayout(new GridLayout(2,2));
		panel1.add(lProxyServer);
		panel1.add(m_tProxyServer);
		panel1.add(lProxyPort);
		panel1.add(m_tProxyPort);

		panel3.setLayout(new GridLayout(2,1));
		panel3.add(m_cbProxy);
		panel3.add(panel1);
*/		
		panel0.add(lServer);
 		panel1.add(m_tServer);
		panel0.add(lPort);
		panel1.add(m_tPort);
		panel0.add(lUser);
		panel1.add(m_tUser);
		panel0.add(lPwd);
		panel1.add(m_tPwd);
		panelButton.add(ok);
		panelButton.add(cancel);
 //		getContentPane().add("Center",panel3); 
  		getContentPane().add("South",panelButton);
 		getContentPane().add("West",panel0);
		getContentPane().add("East",panel1);
		pack();		
	}
	
	public void changeLook_Feel(String which)
	{
		try
		{
			UIManager.setLookAndFeel(which); 
 			SwingUtilities.updateComponentTreeUI(this);
			
		}
		catch(Exception E)
		{
			// Fehler beim Wechseln
		}
	}
	
	void setupActionListener()
	{	
		ok.addActionListener(this);
		cancel.addActionListener(this);
	}
	
	public boolean isOk()
	{
		return result;
	}
	
	public void doModal()
	{
		result =false;
		Point parloc = m_fOwner.getLocation();
		int x = m_fOwner.getWidth() - getWidth();
		int y = m_fOwner.getHeight() - getHeight();
		setLocation(parloc.x + x/2, parloc.y + y/2);
		m_tServer.setText(m_sServer);
		m_tUser.setText(m_sUser);
		m_tPwd.setText(m_sPwd);
		m_tPort.setText(new Integer(m_iPort).toString());
		m_cbProxy.setState(m_bProxy);
		m_tProxyServer.setText(m_sProxyServer);
		m_tProxyPort.setText(new Integer(m_iProxyPort).toString());
		setVisible(true);
	}
	
	public void actionPerformed(ActionEvent event)
	{
		result = event.getActionCommand().equals("Ok");
		if (result)
		{
			m_sServer = m_tServer.getText();
			m_sUser = m_tUser.getText();
			m_sPwd = m_tPwd.getText();
			m_iPort = Integer.parseInt(m_tPort.getText());
			m_bProxy = m_cbProxy.getState();
			m_sProxyServer = m_tProxyServer.getText();
			m_iProxyPort = Integer.parseInt(m_tProxyPort.getText());
		}
		setVisible(false);
		dispose();
	}
	
}
