package com.jdauny.client;
import javax.swing.*;
import java.awt.event.*;
import java.awt.*;

public class Dialog_Store extends JDialog implements ActionListener
{
	boolean result;
	String m_sFilename;
	String m_sInfo;
	JButton ok;
	JButton cancel;
	JLabel lFilename;
	JLabel lInfo;
	JTextField m_tFilename;
	JTextArea m_tInfo;
	JPanel panelButton;
	JPanel panel0;
	JPanel panel1;
	JFrame m_fOwner;
	
	public Dialog_Store(JFrame owner)
	{
		super(owner,"Store",true);
		m_fOwner = owner;
		buildGUI();
		setupActionListener();
	}
	
	void buildGUI()
	{
		ok = new JButton("Ok");
		cancel = new JButton("Cancel");
		panelButton = new JPanel();
 		panel0 = new JPanel(); 
 		panel1 = new JPanel();		
		panel0.setLayout(new BorderLayout()); 
		panel1.setLayout(new BorderLayout());
		m_tFilename = new JTextField(10);
		m_tInfo = new JTextArea(6,5);
		lFilename = new JLabel("Filename:");
		lInfo = new JLabel("Info:");
		panel0.add("North",lFilename);
		panel0.add("Center",m_tFilename);
		panel1.add("North",lInfo);
		panel1.add("Center",m_tInfo);

		panelButton.add(ok);
		panelButton.add(cancel);
 		getContentPane().add("South",panelButton);
		getContentPane().add("North",panel0);
		getContentPane().add("Center",panel1);
		pack();
	}
	
	public void changeLook_Feel(String which)
	{
		try
		{
			UIManager.setLookAndFeel(which); 
 			SwingUtilities.updateComponentTreeUI(this);
			
		}
		catch(Exception E)
		{
			// Fehler beim Wechseln
		}
	}
	
	void setupActionListener()
	{	
		ok.addActionListener(this);
		cancel.addActionListener(this);
	}
	
	public boolean isOk()
	{
		return result;
	}
	
	public void doModal()
	{
		result = false;
		Point parloc = m_fOwner.getLocation();
		int x = m_fOwner.getWidth() - getWidth();
		int y = m_fOwner.getHeight() - getHeight();
		setLocation(parloc.x + x/2, parloc.y + y/2);
		setVisible(true);
	}
	
	public void actionPerformed(ActionEvent event)
	{
		result = event.getActionCommand().equals("Ok");
		if (result)
		{
			m_sFilename = m_tFilename.getText();
			m_sInfo = m_tInfo.getText();
		}
		setVisible(false);
		dispose();
	}
	
}
