/** Java class "Configer.java" generated from Poseidon for UML.
 *  Poseidon for UML is developed by <A HREF="http://www.gentleware.com">Gentleware</A>.
 *  Generated with <A HREF="http://jakarta.apache.org/velocity/">velocity</A> template engine.
 */
package logger;

import java.util.*;

public class Configer extends StreamHandlerPoolAccesser {


    private BitSet disabled_streamhandler_;

    public Configer(StreamHandlerPool streamHandlerPool) {
        super(streamHandlerPool);
	disabled_streamhandler_=new BitSet();
    }


/**
 * Does ...
 *
 * @param which_loggers ...
 * @param new_config ...
 */
    public void switchOnConfigFlags(BitSet which_loggers, BitSet new_config) throws StoreException{

	//Enumeration stream_handlers=getStreamHandler(which_loggers);
	StreamHandler act_stream_handler;
	BitSet stream_handler_config;

	for (Enumeration stream_handlers=getStreamHandler(which_loggers); stream_handlers.hasMoreElements(); ) {
	    act_stream_handler=(StreamHandler)stream_handlers.nextElement();
	    stream_handler_config=act_stream_handler.getConfig();
	    //sets config bits specified int new_config to 1
	    stream_handler_config.or(new_config);
	    act_stream_handler.setConfig(stream_handler_config);
	}

	//If logging gets enabled add those loggers
	if(new_config.get(0))
	{
//	    enabled_streamhandler_.or(which_loggers);
	    disabled_streamhandler_.andNot(which_loggers);
	}

        // your code here
    } // end switchOnConfigFlags

/**
 * Does ...
 *
 * @param which_loggers ...
 * @param new_config ...
 */
    public void switchOffConfigFlags(BitSet which_loggers, BitSet new_config) throws StoreException{
	StreamHandler act_stream_handler;
	BitSet stream_handler_config;

	for (Enumeration stream_handlers=getStreamHandler(which_loggers); stream_handlers.hasMoreElements(); ) {
	    act_stream_handler=(StreamHandler)stream_handlers.nextElement();
	    stream_handler_config=act_stream_handler.getConfig();
	    //sets config bits specified int new_config to 0
	    stream_handler_config.andNot(new_config);
	    act_stream_handler.setConfig(stream_handler_config);
	}

	//If logging gets enabled add those loggers
	if(new_config.get(0))
	    //enabled_streamhandler_.andNot(which_loggers);
       	    disabled_streamhandler_.or(which_loggers);
    } // end switchOffConfigFlags

/**
 * Does ...
 *
 * @param which_loggers ...
 * @param new_prefix ...
 */
    public void setLoggingUnitPrefix(BitSet which_loggers, String new_prefix) throws StoreException {

	StreamHandler act_stream_handler;
	BitSet stream_handler_config;

	for (Enumeration stream_handlers=getStreamHandler(which_loggers); stream_handlers.hasMoreElements(); )
        {
	    act_stream_handler=(StreamHandler)stream_handlers.nextElement();
	    act_stream_handler.setPrefix(new_prefix);
	}
    }

/**
 * Does ...
 *
 * @return A BitSet with ...
 */
    public BitSet getBitSetOfDisabledStreamHandlers() {
        return disabled_streamhandler_;
    }

    public static void main(String[] agrs)
    {
        boolean test_result = true;
        StreamHandlerPool test_pool = new StreamHandlerPool();
        StreamHandler test_handler =  new StreamHandler(null);
	Configer test_configer = new Configer(test_pool);

	BitSet s=new BitSet();
	s.set(30);

	BitSet c=new BitSet();
	c.set(0);
/*
        try
        {
            test_pool.addStreamHandler(30,test_handler);
	    test_configer.switchOnConfigFlags(s,c);

	    BitSet en=test_configer.getBitSetOfEnabledStreamHandlers();
	    if(!en.get(30))
		test_result = false;

	    BitSet cfg=test_handler.getConfig();
	    if(!cfg.get(0))
		test_result = false;

	    test_configer.switchOffConfigFlags(s,c);

	    en=test_configer.getBitSetOfEnabledStreamHandlers();
	    if(en.get(30))
		test_result = false;

	    cfg=test_handler.getConfig();
	    if(cfg.get(0))
		test_result = false;

        }
        catch(StoreException e)
        {
            test_result = false;
        }
*/
        System.out.println("Test StreamHandlerPool: "+test_result);
    }





}




