package logger;

/** Java class "Creater.java" generated from Poseidon for UML.
 *  Poseidon for UML is developed by <A HREF="http://www.gentleware.com">Gentleware</A>.
 *  Generated with <A HREF="http://jakarta.apache.org/velocity/">velocity</A> template engine.
 */
import java.util.*;
import java.io.*;

/**
 * <p>
 * throws Exception
 * InitPhase over
 *
 * @author H. Adam
 * </p>
 */
public class Creater
{

  ///////////////////////////////////////
  // attributes


/**
 * <p>
 * Represents ...
 * </p>
 */
    private boolean init_phase_;

/**
 * <p>
 * Represents ...
 * </p>
 */
    private BitSet created_streamhandler_;

   ///////////////////////////////////////
   // associations

/**
 * <p>
 *
 * </p>
 */
    private StreamHandlerPool streamhandler_pool_;


  ///////////////////////////////////////
  // operations


/**
 * <p>
 * Does ...
 * </p><p>
 *
 * </p><p>
 *
 * @param logger_id ...
 * </p><p>
 * @param stream_to_log_to ...
 * </p>
 */
    public void addStreamHandler(int logger_id, OutputStream stream_to_log_to) throws PhaseException
    { /** lock-end */
        if(init_phase_)
        {
            try
            {
                streamhandler_pool_.addStreamHandler(logger_id,new StreamHandler(stream_to_log_to));
                created_streamhandler_.set(logger_id);
            }
            catch(StoreException e)
            {
                System.out.println(e.toString());
            }
        }
        else
        {
            throw new PhaseException("initial phase is over");
        }

    } // end addStreamHandler        /** lock-begin */

/**
 * <p>
 * Does ...
 * </p><p>
 *
 * @return a Creater with ...
 * </p><p>
 * @param streamhandler_pool ...
 * </p>
 */
    public  Creater(StreamHandlerPool streamhandler_pool)
    { /** lock-end */
        streamhandler_pool_ = streamhandler_pool;
        init_phase_ = true;
        created_streamhandler_ = new BitSet();
    } // end Creater        /** lock-begin */

/**
 * <p>
 * Does ...
 * </p><p>
 *
 * @return a BitSet with ...
 * </p>
 */
    public BitSet getBitSetOfCreatedStreamHandler()
    {  /** lock-end */
         return created_streamhandler_;
    } // end getBitSetOfCreatedStreamHandler        /** lock-begin */

/**
 * <p>
 * Does ...
 * </p><p>
 *
 * </p>
 */
    public void enterLoggingState()
    {  /** lock-end */
        init_phase_ = false;
    } // end enterLoggingState        /** lock-begin */

} // end Creater



