package logger;

/** Java class "Logger.java" generated from Poseidon for UML.
 *  Poseidon for UML is developed by <A HREF="http://www.gentleware.com">Gentleware</A>.
 *  Generated with <A HREF="http://jakarta.apache.org/velocity/">velocity</A> template engine.
 */
import java.util.*;
import java.io.*;

/**
 * <p>
 *
 * @author H. Adam
 * </p>
 */
public class Logger {

  ///////////////////////////////////////
  // attributes

/**
 * <p>
 * Represents ...
 * </p>
 */
    private static Writer writer_;
/**
 * <p>
 * Represents ...
 * </p>
 */
    private static Configer configer_;
/**
 * <p>
 * Represents ...
 * </p>
 */
    private static Creater creater_;

/**
 * <p>
 * Represents ...
 * </p>
 */
    private static boolean report_exception_ = true;

/**
 * <p>
 * Represents ...
 * </p>
 */
    private static boolean mute_ = false;

  ///////////////////////////////////////
  // operations


/**
 * <p>
 * Does ...
 * </p><p>
 *
 * </p>
 */
    private static void initLogger()
    { /** lock-end */
        StreamHandlerPool pool = new StreamHandlerPool();
        creater_ = new Creater(pool);
        writer_ = new Writer(pool);
        configer_ = new Configer(pool);
//        mute_ = false;
//        report_exception_ = true;
    } // end addLoggingUnit        /** lock-begin */


/**
 * <p>
 * Does ...
 * </p><p>
 *
 * </p><p>
 *
 * @param logger_id ...
 * </p><p>
 * @param stream_to_log_to ...
 * </p>
 */
    public static void addLoggingUnit(int logger_id, OutputStream stream_to_log_to) throws LoggerException
    { /** lock-end */
        if(creater_ == null)
            initLogger();
        if(stream_to_log_to == null)
        {
            if(report_exception_) throw new LoggerException("OutputStream must not be null");
        }
        else
           creater_.addStreamHandler(logger_id,stream_to_log_to);
    } // end addLoggingUnit        /** lock-begin */

/**
 * <p>
 * Does ...
 * </p><p>
 *
 * </p><p>
 *
 * @param which_loggers ...
 * </p><p>
 * @param new_config ...
 * </p>
 */
    public static void switchOnConfigFlags(BitSet which_loggers, BitSet new_config) throws LoggerException
    { /** lock-end */
        if(configer_ == null)
        {
           if(report_exception_) throw new LoggerException("no LoggingUnit to config");
        }
        else
           configer_.switchOnConfigFlags(which_loggers,new_config);
    } // end switchOnConfigFlags        /** lock-begin */

/**
 * <p>
 * Does ...
 * </p><p>
 *
 * </p><p>
 *
 * @param which_logger ...
 * </p><p>
 * @param new_config ...
 * </p>
 */
    public static void switchOnConfigFlags(int which_logger, BitSet new_config) throws LoggerException
    { /** lock-end */
        if(configer_ == null)
        {
            if(report_exception_) throw new LoggerException("no LoggingUnit to config");
        }
        else
        {
            BitSet to_config = new BitSet();
            to_config.set(which_logger);
            configer_.switchOnConfigFlags(to_config,new_config);
        }
    } // end switchOnConfigFlags        /** lock-begin */

/**
 * <p>
 * Does ...
 * </p><p>
 *
 * </p><p>
 *
 * @param which_loggers ...
 * </p><p>
 * @param new_config ...
 * </p>
 */
    public static void switchOffConfigFlags(BitSet which_loggers, BitSet new_config) throws LoggerException
    { /** lock-end */
        if(configer_ == null)
        {
            if(report_exception_) throw new LoggerException("no LoggingUnit to config");
        }
        else
            configer_.switchOffConfigFlags(which_loggers,new_config);
    } // end switchOnConfigFlags        /** lock-begin */

/**
 * <p>
 * Does ...
 * </p><p>
 *
 * </p><p>
 *
 * @param which_logger ...
 * </p><p>
 * @param new_config ...
 * </p>
 */
    public static void switchOffConfigFlags(int which_logger, BitSet new_config) throws LoggerException
    { /** lock-end */
        if(configer_ == null)
        {
            if(report_exception_) throw new LoggerException("no LoggingUnit to config");
        }
        else
        {
            BitSet to_config = new BitSet();
            to_config.set(which_logger);
            configer_.switchOffConfigFlags(to_config,new_config);
        }
    } // end switchOffConfigFlags        /** lock-begin */

/**
 * <p>
 * Does ...
 * </p><p>
 *
 * </p><p>
 *
 * @param which_loggers ...
 * </p><p>
 * @param new_prefix ...
 * </p>
 */
    public static void setLoggingUnitPrefix(BitSet which_loggers, String new_prefix) throws LoggerException
    { /** lock-end */
        if(configer_ == null)
        {
            if(report_exception_) throw new LoggerException("no LoggingUnit to config");
        }
        else
            configer_.setLoggingUnitPrefix(which_loggers,new_prefix);
    } // end setLoggingUnitPrefix        /** lock-begin */

/**
 * <p>
 * Does ...
 * </p><p>
 *
 * </p><p>
 *
 * @param which_logger ...
 * </p><p>
 * @param new_prefix ...
 * </p>
 */
    public static void setLoggingUnitPrefix(int which_logger, String new_prefix) throws LoggerException
    { /** lock-end */
        if(configer_ == null)
        {
            if(report_exception_) throw new LoggerException("no LoggingUnit to config");
        }
        else
        {
            BitSet to_config = new BitSet();
            to_config.set(which_logger);
            configer_.setLoggingUnitPrefix(to_config,new_prefix);
        }
    } // end setLoggingUnitPrefix        /** lock-begin */

/**
 * <p>
 * Does ...
 * </p><p>
 *
 * </p>
 */
    public static void enterLoggingState() throws LoggerException
    { /** lock-end */
        if(creater_ == null)
        {
            if(report_exception_) throw new LoggerException("no LoggingUnits exists");
        }
        else
        {
            creater_.enterLoggingState();
            writer_.enterLoggingState();
        }
    } // end enterLoggingState        /** lock-begin */

/**
 * <p>
 * Does ...
 * </p><p>
 *
 * </p><p>
 *
 * @param which_loggers ...
 * </p><p>
 * @param message ...
 * </p>
 */
    public static void log(BitSet which_loggers, String message) throws LoggerException
    { /** lock-end */
        if(writer_ == null)
        {
            if(report_exception_) throw new LoggerException("no LoggingUnits exists");
        }
        else
        {
            if(!mute_)
            {
                BitSet which_loggers_clone = (BitSet) which_loggers.clone();
                BitSet which_loggers_test_clone = (BitSet) which_loggers.clone();
                which_loggers_test_clone.andNot(creater_.getBitSetOfCreatedStreamHandler());
                if(which_loggers_test_clone.length() != 0) throw new LoggerException("unknown LoggingUnit Id");
                which_loggers_clone.andNot(configer_.getBitSetOfDisabledStreamHandlers());
                writer_.writeMessage(which_loggers_clone,message);
            }
        }
    } // end log        /** lock-begin */

/**
 * <p>
 * Does ...
 * </p><p>
 *
 * </p><p>
 *
 * @param which_logger ...
 * </p><p>
 * @param message ...
 * </p>
 */
    public static void log(int which_logger, String message) throws LoggerException
    { /** lock-end */
        if(writer_ == null)
        {
            if(report_exception_) throw new LoggerException("no LoggingUnits exists");
        }
        else
        {
            if(!mute_)
            {
                 BitSet to_log = new BitSet();
                 to_log.set(which_logger);
                 BitSet to_log_test = (BitSet)to_log.clone();
                 to_log_test.andNot(creater_.getBitSetOfCreatedStreamHandler());
                 if(to_log_test.length() != 0)
                 {
                     if(report_exception_) throw new LoggerException("unknown LoggerUnit ID");
                 }
                 else
                 {
                     to_log.andNot(configer_.getBitSetOfDisabledStreamHandlers());
                     writer_.writeMessage(to_log,message);
                 }
            }
        }
    } // end log        /** lock-begin */

/**
 * <p>
 * Does ...
 * </p><p>
 *
 * </p>
 */
    public static void doMute()
    { /** lock-end */
        mute_ = true;
    } // end doMute        /** lock-begin */

/**
 * <p>
 * Does ...
 * </p><p>
 *
 * </p>
 */
    public static void unMute()
    { /** lock-end */
        mute_ = false;
    } // end unMute        /** lock-begin */

/**
 * <p>
 * Does ...
 * </p><p>
 *
 * </p>
 */
    public static void enableAllLoggingUnits()
    { /** lock-end */
        if(creater_ != null)
        {
            BitSet enable_logging = new BitSet();
            enable_logging.set(0);
            try
            {
                configer_.switchOnConfigFlags(creater_.getBitSetOfCreatedStreamHandler(),enable_logging);
            }
            catch(StoreException e)
            {
                e.printStackTrace();
            }
        }
    } // end enableAllLoggingUnits        /** lock-begin */

/**
 * <p>
 * Does ...
 * </p><p>
 *
 * </p>
 */
    public static void disableAllLoggingUnits()
    { /** lock-end */
        if(creater_ != null)
        {
            BitSet disable_logging = new BitSet();
            disable_logging.set(0);
            try
            {
                configer_.switchOffConfigFlags(creater_.getBitSetOfCreatedStreamHandler(),disable_logging);
            }
            catch(StoreException e)
            {
                e.printStackTrace();
            }
        }
    } // end disableAllLoggingUnits        /** lock-begin */


/**
 * <p>
 * Does ...
 * </p><p>
 *
 * </p>
 */
    public static void setReportExceptions(boolean set_report)
    {
        report_exception_ = set_report;
    }

    public static void main(String[] args)
    {
        boolean test_result = true;
        OutputStream test_writer = null;
        try
        {
//          test_writer = new FileOutputStream("test.tst");
          test_writer = (new java.net.Socket("localhost",6000)).getOutputStream();
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }

//      Logger.setReportExceptions(false);

        Logger.addLoggingUnit(1,test_writer);
        Logger.addLoggingUnit(2,test_writer);
        Logger.addLoggingUnit(3,test_writer);
        Logger.addLoggingUnit(4,test_writer);
        Logger.addLoggingUnit(10,test_writer);
//      Logger.enableAllLoggingUnits();
        BitSet config = new BitSet();
        BitSet select = new BitSet();
        select.set(1);
        select.set(2);
        select.set(3);
        select.set(4);
        select.set(10);

        config.set(2);

        Logger.switchOnConfigFlags(select,config);
        Logger.setLoggingUnitPrefix(1,"watcher1");
        Logger.setLoggingUnitPrefix(2,"watcher2");
        Logger.setLoggingUnitPrefix(3,"watcher3");
        Logger.setLoggingUnitPrefix(10,"watcher10");

        Logger.enterLoggingState();


        Logger.log(1,"Logger Test 1");
        Logger.log(2,"Logger Test 2");
        Logger.log(3,"Logger Test 3");
        Logger.log(4,"Logger Test 4");
        Logger.log(10,"Logger Test 10");

        config.set(1);
        Logger.switchOnConfigFlags(select,config);

        Logger.log(1,"Logger TimeStamp 1");
        Logger.log(2,"Logger TimeStamp 2");
        Logger.log(3,"Logger TimeStamp 3");
        Logger.log(4,"Logger TimeStamp 4");
        Logger.log(10,"Logger TimeStamp 10");

        config.clear();
        config.set(1);
        Logger.switchOffConfigFlags(select,config);
        config.set(2);
        Logger.switchOffConfigFlags(4,config);

        Logger.log(1,"Logger Test 1");
        Logger.log(2,"Logger Test 2");
        Logger.log(3,"Logger Test 3");
        Logger.log(4,"Logger Test 4");
        Logger.log(10,"Logger Test 10");

        System.out.println("Test Logger: "+test_result);
    }

} // end Logger



