package com.jdauny;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author unbekannt
 * @version 1.0
 */

public class DaunyNativeFunctions
{
  private static DaunyNativeFunctions singleton_;
  static
  {
    System.loadLibrary("daunytools");
    singleton_ = new DaunyNativeFunctions();
  }
  public static int isWindowsNt()
  {
    return singleton_.IsWindowsNT();
  }

  public static String encryptPassword(String login_name,String connection_key)
  {
    return singleton_.EncryptPasswort(login_name,connection_key);
  }

  public static int startDauny(String path)
  {
    return singleton_.StartDauny(path);
  }

  public static int stopDauny(String path)
  {
    return singleton_.StopDauny(path);
  }

  public static int startDaunyService()
  {
    return singleton_.StartDaunyService();
  }

  public static int stopDaunyService()
  {
    return singleton_.StopDaunyService();
  }

  public static void main(String args[])
  {
    if(1==DaunyNativeFunctions.isWindowsNt())
      System.out.println("Windows NT");
    else
      System.out.println("was anders");
  }

  private native int IsWindowsNT();
  private native String EncryptPasswort(String login_name,String connection_key);
  private native int StartDauny(String path);
  private native int StopDauny(String path);
  private native int StartDaunyService();
  private native int StopDaunyService();
}