package com.jdauny.client;
import javax.swing.*;
import java.awt.event.*;
import java.awt.*;

public class Dialog_CMD extends JDialog implements ActionListener
{
	JButton close;
	JButton send;
	JButton get;


	JLabel m_linput;
	
	JTextField m_tfSend;
	JTextArea m_taSend;
	JTextArea m_taReceive;

	JPanel panelButton;
	JPanel panel0; 
	JPanel panel1;	
	JPanel panel2;
	JPanel isent;
	JPanel ireceived;
	DaunyGUI m_fOwner;
	
	public Dialog_CMD(DaunyGUI owner)
	{
		super(owner,"CMD",true);
		setModal(false);
		m_fOwner = owner;
		buildGUI();
		setupActionListener();
	}
	
	void buildGUI()
	{
		close = new JButton("Close");
		send = new JButton("Send"); 
		get = new JButton("Get");

		m_linput = new JLabel("Input:");
		m_tfSend = new JTextField(); 
		m_tfSend.setColumns(20);
		
		m_taSend = new JTextArea();  
		m_taSend.setColumns(15); 
		m_taSend.setRows(10); 
		
		m_taReceive = new JTextArea();
		m_taReceive.setColumns(15); 
		m_taReceive.setRows(10);
				
		panelButton = new JPanel();
 		panel0 = new JPanel();
		panel1 = new JPanel();
		panel2 = new JPanel();
		isent = new JPanel();
		ireceived = new JPanel();
//		panel0.setLayout(); 
 		panel1.setLayout(new BorderLayout());
		panel2.setLayout(new BorderLayout());
		isent.setLayout(new BorderLayout()); 
		ireceived.setLayout(new BorderLayout());		
		
		panel0.add(m_linput);
		panel0.add(m_tfSend);
		panel2.add("West",panel0);  
		panel2.add("East",send); 		
 		isent.add("North",new JLabel("Sent:"));
		isent.add("Center",new JScrollPane(m_taSend));
		ireceived.add("North",new JLabel("Received:"));
		ireceived.add("Center",new JScrollPane(m_taReceive));

		
		
		panel1.add("North",panel2); 
		panel1.add("Center",isent);		
		panel1.add("South",ireceived);
		
	//	panelButton.add(send);
	//	panelButton.add(get); 
		panelButton.add(close);
 		getContentPane().add("South",panelButton);
//		getContentPane().add("Center",m_taReceive);
		getContentPane().add("North",panel1);
		pack();
	}
	
	public void changeLook_Feel(String which)
	{
		try
		{
			UIManager.setLookAndFeel(which); 
 			SwingUtilities.updateComponentTreeUI(this);
			
		}
		catch(Exception E)
		{
			// Fehler beim Wechseln
		}
	}
	
	void setupActionListener()
	{	
		close.addActionListener(this);
		send.addActionListener(this);
		get.addActionListener(this);
	}
	
	public void UpdateReceive(String message)
	{
		m_taReceive.setText(message+"\n"+m_taReceive.getText());
	} 
	
	public void UpdateSend(String message)
	{
		m_taSend.setText(message+"\n"+m_taSend.getText());
	}
	
	public void doModal()
	{
		Point parloc = m_fOwner.getLocation();
		int x = m_fOwner.getWidth() - getWidth();
		int y = m_fOwner.getHeight() - getHeight();
		setLocation(parloc.x + x/2, parloc.y + y/2);
		setVisible(true);
	}
	
	public void actionPerformed(ActionEvent event)
	{
		String cmd = event.getActionCommand();
		if (cmd.equals("Close"))
		{
			setVisible(false);
			dispose();
		}
		if (cmd.equals("Send"))
		{
//			System.out.println("Send -> "+m_tfSend.getText());
			m_fOwner.m_dsSocket.requestSend(m_tfSend.getText());	
		} 
		if (cmd.equals("Get"))
		{
//			System.out.println("Get -> "+m_tfSend.getText());
		}
		
	}
	
}
