package com.jdauny.client;
import javax.swing.*;
import java.awt.event.*;
import java.awt.*;

public class Dialog_Download extends JDialog implements ActionListener
{
	boolean result;
	String m_sDir;
	public int m_iRetries,m_iSame,m_iPriority;
	JButton ok;
	JButton cancel;
	JLabel lDir;
	JLabel lRetries;
	JLabel lSame;
	JLabel lPriority;
	JTextField m_tDir;
	JTextField m_tRetries;
	JTextField m_tSame;
	JTextField m_tPriority;
	JPanel panelButton;
	JPanel panel0;
	JFrame m_fOwner;
	
	public Dialog_Download(JFrame owner)
	{
		super(owner,"Download Options",true);
		m_fOwner = owner;
		buildGUI();
		setupActionListener();
	}
	
	void buildGUI()
	{
		ok = new JButton("Ok");
		cancel = new JButton("Cancel");
		panelButton = new JPanel();
 		panel0 = new JPanel();
		panel0.setLayout(new GridLayout(4,2));
		m_tDir = new JTextField(10);
		m_tRetries = new JTextField(6);
		m_tSame = new JTextField(8);
		m_tPriority = new JTextField(8);
		lDir = new JLabel("Directory:");
		lRetries = new JLabel("Retries:");
		lSame = new JLabel("Same:");
		lPriority = new JLabel("Priority:");
		panel0.add(lDir);
		panel0.add(m_tDir);
		panel0.add(lRetries);
		panel0.add(m_tRetries);
		panel0.add(lSame);
		panel0.add(m_tSame);
		panel0.add(lPriority);
		panel0.add(m_tPriority);
		panelButton.add(ok);
		panelButton.add(cancel);
 		getContentPane().add("South",panelButton);
		getContentPane().add("North",panel0);
		pack();
	}
	
	public void changeLook_Feel(String which)
	{
		try
		{
			UIManager.setLookAndFeel(which); 
 			SwingUtilities.updateComponentTreeUI(this);
			
		}
		catch(Exception E)
		{
			// Fehler beim Wechseln
		}
	}
	
	void setupActionListener()
	{	
		ok.addActionListener(this);
		cancel.addActionListener(this);
	}
	
	public boolean isOk()
	{
		return result;
	}
	
	public void doModal()
	{
		result = false;
		Point parloc = m_fOwner.getLocation();
		int x = m_fOwner.getWidth() - getWidth();
		int y = m_fOwner.getHeight() - getHeight();
		setLocation(parloc.x + x/2, parloc.y + y/2);
		m_tDir.setText(m_sDir);
		m_tRetries.setText(new Integer(m_iRetries).toString()); 
		m_tSame.setText(new Integer(m_iSame).toString());
		m_tPriority.setText(new Integer(m_iPriority).toString());
		setVisible(true);
	}
	
	public void actionPerformed(ActionEvent event)
	{
		result = event.getActionCommand().equals("Ok");
		if (result)
		{
			m_sDir = m_tDir.getText();
			m_iRetries = Integer.parseInt(m_tRetries.getText()); 
			m_iSame = Integer.parseInt(m_tSame.getText());
			m_iPriority = Integer.parseInt(m_tPriority.getText());
		}
		setVisible(false);
		dispose();
	}
	
}
