package com.jdauny.client;
import javax.swing.*;
import java.awt.event.*;
import java.awt.*;

public class Dialog_Programs extends JDialog implements ActionListener
{
	boolean result;
	public String m_sFtp,m_sTelnet;
	
	JButton ok;
	JButton cancel;
	JButton lookftp;
	JButton looktelnet;	
	JLabel lFtp;
	JLabel lTelnet;
	JTextField m_tFtp;
	JTextField m_tTelnet;
	JFrame m_fOwner;

	
	public Dialog_Programs(JFrame owner)
	{
		super(owner,"Programs Options",true);
		m_fOwner = owner;
		buildGUI();
		setupActionListener();
	}
	
	void buildGUI()
	{
		JPanel panelButton;
		JPanel panel0;
		JPanel panel1;
		JPanel panel2;

		ok = new JButton("Ok");
		cancel = new JButton("Cancel");
		lookftp = new JButton("..");
		looktelnet = new JButton("..");		
		lookftp.setActionCommand("ftpexe"); 
 		looktelnet.setActionCommand("telnetexe");
		panelButton = new JPanel();
 		panel0 = new JPanel();
		panel1 = new JPanel();	
		panel2 = new JPanel();	
 		panel0.setLayout(new GridLayout(2,1));
 		panel1.setLayout(new GridLayout(2,1));
		panel2.setLayout(new GridLayout(2,1));
		m_tFtp = new JTextField(10);
		m_tTelnet = new JTextField(10);
		lFtp = new JLabel("Ftp:");
		lTelnet = new JLabel("Telnet:");

		panel0.add(lFtp);
		panel0.add(lTelnet);
		
		panel1.add(m_tFtp);
		panel1.add("Center",m_tTelnet);

		panel2.add(lookftp); 
		panel2.add(looktelnet);
		panelButton.add(ok);
		panelButton.add(cancel);

  		getContentPane().add("South",panelButton);
 		getContentPane().add("West",panel0);
 		getContentPane().add("Center",panel1);		
		getContentPane().add("East",panel2);		
		pack();		
	}
	
	public void changeLook_Feel(String which)
	{
		try
		{
			UIManager.setLookAndFeel(which); 
 			SwingUtilities.updateComponentTreeUI(this);
			
		}
		catch(Exception E)
		{
			// Fehler beim Wechseln
		}
	}	
	
	void setupActionListener()
	{	
		ok.addActionListener(this);
		cancel.addActionListener(this);
 		lookftp.addActionListener(this);
		looktelnet.addActionListener(this);
	}
	
	public boolean isOk()
	{
		return result;
	}
	
	public void doModal()
	{
		result =false;
		Point parloc = m_fOwner.getLocation();
		int x = m_fOwner.getWidth() - getWidth();
		int y = m_fOwner.getHeight() - getHeight();
		setLocation(parloc.x + x/2, parloc.y + y/2);
		m_tFtp.setText(m_sFtp);
		m_tTelnet.setText(m_sTelnet);
		setVisible(true);
	}
	
	public void actionPerformed(ActionEvent event)
	{
		String cmd = event.getActionCommand();
		if (cmd.equals("Ok"))
		{
			m_sFtp = m_tFtp.getText();
			m_sTelnet = m_tTelnet.getText();
			result = true;
			setVisible(false);
			dispose();
		}		
		if (cmd.equals("Cancel"))
		{
			result = false;
			setVisible(false);
			dispose();
		}		
		if(cmd.equals("ftpexe"))
		{
			JFileChooser search = new JFileChooser();
			int check = search.showOpenDialog(this);
		 	if (check == JFileChooser.APPROVE_OPTION) 
			{
				m_tFtp.setText(search.getSelectedFile().getPath());
			}
        }
		
		if(cmd.equals("telnetexe"))
		{
			JFileChooser search = new JFileChooser();
			int check = search.showOpenDialog(this);
			if (check == JFileChooser.APPROVE_OPTION) 
			{
				m_tTelnet.setText(search.getSelectedFile().getPath());
			}
		}
		
		
	}
	
}
