package com.jdauny.client;
import javax.swing.*;
import java.awt.event.*;
import java.awt.*;

public class Dialog_PwdChange extends JDialog implements ActionListener
{
	public boolean result;
	String m_sOldPwd;
	String m_sNewPwd;
	
	JButton ok;
	JButton cancel;
	JLabel loldPwd;
	JLabel lnewPwd;
	JLabel lrepeatPwd;
 	JPasswordField m_toPwd;
	JPasswordField m_tnPwd;
	JPasswordField m_trPwd;	

	JPanel panelButton;
	JPanel panel0;
	JPanel panel1;
	JPanel panel3;
	JFrame m_fOwner;

	
	public Dialog_PwdChange(JFrame owner)
	{
		super(owner,"Change Password",true);
		m_fOwner = owner;
		buildGUI();
		setupActionListener();
		setResizable(false);
	}
	
	void buildGUI()
	{
		ok = new JButton("Ok");
		cancel = new JButton("Cancel");
		panelButton = new JPanel();
 		panel0 = new JPanel();
		
		panel0.setLayout(new GridLayout(3,2));

 		m_toPwd = new JPasswordField(8);
		m_tnPwd = new JPasswordField(8);
		m_trPwd = new JPasswordField(8);

		loldPwd = new JLabel("old PWD:");
		lnewPwd = new JLabel("new PWD:");
		lrepeatPwd = new JLabel("repeat PWD:");

		panel0.add(loldPwd);
		panel0.add(m_toPwd);
		panel0.add(lnewPwd);
		panel0.add(m_tnPwd);
		panel0.add(lrepeatPwd);
		panel0.add(m_trPwd);
		
		panelButton.add(ok);
		panelButton.add(cancel);
  		getContentPane().add("South",panelButton);
		getContentPane().add("North",panel0);
		pack();		
	}
	
	public void changeLook_Feel(String which)
	{
		try
		{
			UIManager.setLookAndFeel(which); 
 			SwingUtilities.updateComponentTreeUI(this);
			
		}
		catch(Exception E)
		{
			// Fehler beim Wechseln
		}
	}
	
	void setupActionListener()
	{	
		ok.addActionListener(this);
		cancel.addActionListener(this);
	}
	
	public boolean isOk()
	{
		return result;
	}
	
	public void doModal(String oldpwd)
	{
		result =false;
		Point parloc = m_fOwner.getLocation();
		int x = m_fOwner.getWidth() - getWidth();
		int y = m_fOwner.getHeight() - getHeight();
		setLocation(parloc.x + x/2, parloc.y + y/2);
		m_sOldPwd = oldpwd;
		m_toPwd.setText("");
		m_tnPwd.setText("");
		m_trPwd.setText("");
		setVisible(true);
	}
	
	public void actionPerformed(ActionEvent event)
	{
		result = event.getActionCommand().equals("Ok");
		if (result)
		{
			if (m_sOldPwd.equals(m_toPwd.getText()))
			{
				if (m_tnPwd.getText().equals(m_trPwd.getText()))
				{
					m_sNewPwd = m_tnPwd.getText();
					setVisible(false);
					dispose();
				}
				else
				{
					
					result = false;
					
				}
			}
			else
			{
				result = false;
				
			}
		}
		else
		{
			setVisible(false);
			dispose();
		}
	}
	
	public String getNewPwd()
	{
		String help = m_sNewPwd;
		m_sNewPwd = "";
		return help;
	}
	
}
