package com.jdauny.client;

import javax.swing.table.*;
import javax.swing.*;

/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2002</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class LinkTableColumnModel extends DefaultTableColumnModel
{
  final String[] COLUMN_NAME = {"ID","Filename","Filesize","State","Error","Progress"};
  final int[] COLUMN_WIDTH = {30,300,60,60,100};
  public LinkTableColumnModel()
  {
    initColumnModel();
  }

  void initColumnModel()
  {
    TableColumn column;
    DefaultTableCellRenderer string_renderer = new DefaultTableCellRenderer();
    string_renderer.setHorizontalAlignment(JLabel.CENTER);
    for(int column_number=0;column_number<COLUMN_NAME.length-1;column_number++)
    {
      column = new TableColumn(column_number);
      column.setCellRenderer(string_renderer);
      column.setWidth(COLUMN_WIDTH[column_number]);
      column.setPreferredWidth(COLUMN_WIDTH[column_number]);
//      column.setMaxWidth(COLUMN_WIDTH[column_number]);
//      column.setMinWidth(COLUMN_WIDTH[column_number]);
      column.setHeaderValue(COLUMN_NAME[column_number]);
      this.addColumn(column);
    }
    ProgressBarRenderer pbr = new ProgressBarRenderer(0, 100);
    pbr.setStringPainted(true);
    column = new TableColumn(COLUMN_NAME.length-1);
    column.setCellRenderer(pbr);
    column.setHeaderValue(COLUMN_NAME[COLUMN_NAME.length-1]);
    this.addColumn(column);
  }
}