package com.jdauny.client;
import javax.swing.*;
import java.awt.event.*;
import java.awt.*;

public class MessageBox extends JDialog implements ActionListener
{
	boolean result;
	JButton ok;
	JPanel panelButton;
	JPanel panel0;
	JFrame m_fOwner;
	JLabel lMessage;
//	String m_sMessage;
	
	public MessageBox(JFrame owner)
	{
		super(owner,"no title",true);
		m_fOwner = owner;
//		m_sMessage = message;
		buildGUI();
		setupActionListener();
	}
	
	void buildGUI()
	{
		ok = new JButton("Ok");
		lMessage = new JLabel("No Message");
		panelButton = new JPanel();
 		panel0 = new JPanel();
		panelButton.add(ok);
		panel0.add(lMessage);
 		getContentPane().add("South",panelButton);
		getContentPane().add("North",panel0);
		pack();
	}
	
	void setupActionListener()
	{	
		ok.addActionListener(this);
	}
	
	public void showMessage(String newtitle,String message)
	{
		setTitle(newtitle);
		setSize(400,getHeight());
		lMessage.setText(message);
		doModal();
	}
	
	public void doModal()
	{
		Point parloc = m_fOwner.getLocation();
		int x = m_fOwner.getWidth() - getWidth();
		int y = m_fOwner.getHeight() - getHeight();
		setLocation(parloc.x + x/2, parloc.y + y/2);
		setVisible(true);
	}
	
	public void changeLook_Feel(String which)
	{
		try
		{
			UIManager.setLookAndFeel(which); 
 			SwingUtilities.updateComponentTreeUI(this);
			
		}
		catch(Exception E)
		{
			// Fehler beim Wechseln
		}
	}
	
	public void actionPerformed(ActionEvent event)
	{
		result = event.getActionCommand().equals("Ok");
		setVisible(false);
		dispose();
	}
	
}
